import _defaults2 from 'lodash/defaults';
import _defaults from 'lodash/defaults';

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import * as React from 'react';

import { connect } from 'react-redux';
import { createStructuredSelector, createSelector } from 'reselect';

export default function featureContent(options) {
  const { getFeatures, sortFeatures, getContent } = _defaults2({}, options, {
    getFeatures: state => state ? state.features : {},
    sortFeatures: features => Object.values(features)
  });

  const mapStateToProps = createStructuredSelector({
    features: createSelector(getFeatures, sortFeatures)
  });

  function mergeProps({ features }, dispatchProps, _ref) {
    let { children } = _ref,
        props = _objectWithoutProperties(_ref, ['children']);

    const content = [];
    features.forEach((feature, featureIndex) => {
      let featureContent = getContent(feature);
      if (featureContent == null) return;
      if (typeof featureContent === 'function') featureContent = featureContent(props);
      if (!Array.isArray(featureContent)) featureContent = [featureContent];
      featureContent.forEach((item, index) => {
        if (React.isValidElement(item) && item.key == null) {
          item = React.cloneElement(item, { key: featureIndex + ':' + index });
        }
        content.push(item);
      });
    });
    return {
      children: children instanceof Function ? children(content) : React.createElement(
        'div',
        null,
        content
      )
    };
  }

  mergeProps.propTypes = {
    features: PropTypes.arrayOf(function () {
      return (typeof bpfrpt_proptype_Feature === 'function' ? bpfrpt_proptype_Feature : PropTypes.shape(bpfrpt_proptype_Feature)).apply(this, arguments);
    }).isRequired
  };
  mergeProps.propTypes = {
    features: PropTypes.arrayOf(function () {
      return (typeof bpfrpt_proptype_Feature === 'function' ? bpfrpt_proptype_Feature : PropTypes.shape(bpfrpt_proptype_Feature)).apply(this, arguments);
    }).isRequired
  };
  const FeatureContent = ({ children }) => children;

  return connect(mapStateToProps, null, mergeProps)(FeatureContent);
}
featureContent.propTypes = {
  getFeatures: PropTypes.func,
  sortFeatures: PropTypes.func,
  getContent: PropTypes.func.isRequired
};
featureContent.propTypes = {
  getFeatures: PropTypes.func,
  sortFeatures: PropTypes.func,
  getContent: PropTypes.func.isRequired
};
import { bpfrpt_proptype_Feature } from 'redux-features';
import { bpfrpt_proptype_Features } from 'redux-features';
import PropTypes from 'prop-types';