'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _defaults4 = require('lodash/defaults');

var _defaults5 = _interopRequireDefault(_defaults4);

exports.default = featureContent;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactRedux = require('react-redux');

var _reselect = require('reselect');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function featureContent(options) {
  var _defaults3 = (0, _defaults5.default)({}, options, {
    getFeatures: function getFeatures(state) {
      return state ? state.features : {};
    },
    sortFeatures: function sortFeatures(features) {
      return (0, _values2.default)(features);
    }
  }),
      getFeatures = _defaults3.getFeatures,
      sortFeatures = _defaults3.sortFeatures,
      getContent = _defaults3.getContent;

  var mapStateToProps = (0, _reselect.createStructuredSelector)({
    features: (0, _reselect.createSelector)(getFeatures, sortFeatures)
  });

  function mergeProps(_ref2, dispatchProps, _ref) {
    var features = _ref2.features;
    var children = _ref.children,
        props = (0, _objectWithoutProperties3.default)(_ref, ['children']);

    var content = [];
    features.forEach(function (feature, featureIndex) {
      var featureContent = getContent(feature);
      if (featureContent == null) return;
      if (typeof featureContent === 'function') featureContent = featureContent(props);
      if (!Array.isArray(featureContent)) featureContent = [featureContent];
      featureContent.forEach(function (item, index) {
        if (React.isValidElement(item) && item.key == null) {
          item = React.cloneElement(item, { key: featureIndex + ':' + index });
        }
        content.push(item);
      });
    });
    return {
      children: children instanceof Function ? children(content) : React.createElement(
        'div',
        null,
        content
      )
    };
  }

  var FeatureContent = function FeatureContent(_ref3) {
    var children = _ref3.children;
    return children;
  };

  return (0, _reactRedux.connect)(mapStateToProps, null, mergeProps)(FeatureContent);
}